/* 
 * EIO Piljardivoistluse Graafika Praktikum
 * 16. detsember 2007
 * (C) Konstantin Tretjakov
 * (C) Dan Bogdanov
 */
// Kasutame allegro teeki
#include "allegro.h"

/*
 * NB! Koodi lugemist tasub alustada funktsiooniga main. See asub koige lopus.
 * ---------------------------------------------------------------------------
 */

/*
 * Joonistamisfunktsioon
 */
void draw() {
  // Kustutame ekraani
  clear_bitmap (screen);

  // 'screen' on piltobjekt, kuhu me saame joonistada kasutades
  // primitiivseid joonistamisfunktsioone:
  putpixel (screen, 30, 30, makecol (255,0,0));
  putpixel (screen, 60, 60, makecol (0,255,0));
  putpixel (screen, 90, 90, makecol (0,0,255));  

  // Sirgjooned
  line (screen, 0, 50, 799, 50, makecol (255, 255, 0));
  line (screen, 50, 0, 50, 599, makecol (0, 255, 255));

  // Ristkylikud
  rect (screen, 100, 100, 175, 175, makecol (128, 128, 255));
  rectfill (screen, 150, 200, 400, 250, makecol (128, 255, 255));
  
  // Ellipsid
  ellipse (screen, 500, 150, 50, 50, makecol (255, 255, 0));
  ellipsefill (screen, 700, 250, 50, 100, makecol (255, 255, 0));


  // Floodfill
  rect (screen, 200, 400, 600, 550, makecol (255, 0, 0));
  ellipse (screen, 400, 475, 100, 50, makecol (255, 0, 0));
  floodfill (screen, 210, 410, makecol (255, 0, 0));

  // Tekst
  textout(screen, font, "Screen 1: draw()", 10, 10, makecol (255, 255, 255));  
}


/*
 * Programmi peameetod. Seadistab graafikasysteemi. 
 *
 */
int main(int argc, char *argv[]) {

  // Sellega peab Allegro programm algama.
  allegro_init ();
  // Ytleme systeemile et tahame kasutada klaviatuuri
  install_keyboard ();
  
  // Valime sobivat graafika reziimi
  // Loome 800x600 akna, sama varvikvaliteediga mis praegu desktopil
  int bits = desktop_color_depth ();
  set_color_depth (bits);
  set_gfx_mode (GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0);
  

  // Teeme joonistamist
  draw();

  // Ootame nupuvajutust
  while (!keypressed ());
  clear_keybuf ();
  
  // Lopp (siin voib kutsuda allegro_exit(), aga see pole kohustuslik)
  return 0;
}

// Allegro tahab seda et olla rohkem platvormist/kompilaatorist soltumatu:
// vt. http://wiki.allegro.cc/END_OF_MAIN
END_OF_MAIN ()

